<!DOCTYPE html>
<html lang="en">
  <head>
    <title>madme_ios_sdk  Reference</title>
    <link rel="stylesheet" type="text/css" href="css/jazzy.css" />
    <link rel="stylesheet" type="text/css" href="css/highlight.css" />
    <meta charset='utf-8'>
    <script src="js/jquery.min.js" defer></script>
    <script src="js/jazzy.js" defer></script>
    
    <script src="js/lunr.min.js" defer></script>
    <script src="js/typeahead.jquery.js" defer></script>
    <script src="js/jazzy.search.js" defer></script>
  </head>
  <body>
    <a title="madme_ios_sdk  Reference"></a>
    <header>
      <div class="content-wrapper">
        <p><a href="index.html">madme_ios_sdk 6.2.1 Docs</a></p>
        <div class="header-right">
          <form role="search" action="search.json">
            <input type="text" placeholder="Search documentation" data-typeahead>
          </form>
        </div>
      </div>
    </header>
    <div class="content-wrapper">
      <p id="breadcrumbs">
        <a href="index.html">madme_ios_sdk Reference</a>
        <img id="carat" src="img/carat.png" alt=""/>
        madme_ios_sdk  Reference
      </p>
    </div>
    <div class="content-wrapper">
      <nav class="sidebar">
        <ul class="nav-groups">
          <li class="nav-group-name">
            <a href="Classes.html">Classes</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Classes/AES.html">AES</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/AES/Error.html">– Error</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/AES/Variant.html">– Variant</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/AES/Encryptor.html">– Encryptor</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMAdPresentationError.html">MMAdPresentationError</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMCampaign.html">MMCampaign</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMError.html">MMError</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMGenericUserAccountStatusChangeContext.html">MMGenericUserAccountStatusChangeContext</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMHomeScreenOption.html">MMHomeScreenOption</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMNotificationProcessingError.html">MMNotificationProcessingError</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMPrivateInitObject.html">MMPrivateInitObject</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMSdk.html">MMSdk</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMUrlProcessingError.html">MMUrlProcessingError</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMUrlSessionEventsProcessingError.html">MMUrlSessionEventsProcessingError</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes.html#/c:@M@madme_ios_sdk@objc(cs)MMViewedNoSurveyNoRatingCampaignContext">MMViewedNoSurveyNoRatingCampaignContext</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Enums.html">Enumerations</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Enums/BlockMode.html">BlockMode</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/CipherError.html">CipherError</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/MMAdPresentationMode.html">MMAdPresentationMode</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/MMAdPresentationResultState.html">MMAdPresentationResultState</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/MMAggregateQualifier.html">MMAggregateQualifier</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/MMHomeScreenOptionType.html">MMHomeScreenOptionType</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/MMNotificationProcessingResultState.html">MMNotificationProcessingResultState</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/MMUrlProcessingResultState.html">MMUrlProcessingResultState</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/MMUrlSessionEventsProcessingResultState.html">MMUrlSessionEventsProcessingResultState</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/MMUserAccountStatus.html">MMUserAccountStatus</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums.html#/PKCS7">PKCS7</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/Padding.html">Padding</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Extensions.html">Extensions</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Extensions/Array.html">Array</a>
              </li>
              <li class="nav-group-task">
                <a href="Extensions.html#/MMCarouselCollectionViewController">MMCarouselCollectionViewController</a>
              </li>
              <li class="nav-group-task">
                <a href="Extensions.html#/MMGeoFencingCampaignDetailsViewController">MMGeoFencingCampaignDetailsViewController</a>
              </li>
              <li class="nav-group-task">
                <a href="Extensions.html#/MMPlist">MMPlist</a>
              </li>
              <li class="nav-group-task">
                <a href="Extensions/NSNotification.html">NSNotification</a>
              </li>
              <li class="nav-group-task">
                <a href="Extensions/Notification.html">Notification</a>
              </li>
              <li class="nav-group-task">
                <a href="Extensions/Notification/Name.html">– Name</a>
              </li>
              <li class="nav-group-task">
                <a href="Extensions.html#/SecureBytes">SecureBytes</a>
              </li>
              <li class="nav-group-task">
                <a href="Extensions.html#/UIControl">UIControl</a>
              </li>
              <li class="nav-group-task">
                <a href="Extensions/UINavigationController.html">UINavigationController</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Protocols.html">Protocols</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Protocols/Cipher.html">Cipher</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/Cryptors.html">Cryptors</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/MMAdPresentationResultProtocol.html">MMAdPresentationResultProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols.html#/c:@M@madme_ios_sdk@objc(pl)MMCampaignContextProtocol">MMCampaignContextProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols.html#/c:@M@madme_ios_sdk@objc(pl)MMCampaignContextProviderProtocol">MMCampaignContextProviderProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/MMClientIdentityProviderProtocol.html">MMClientIdentityProviderProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/MMNotificationProcessingResultProtocol.html">MMNotificationProcessingResultProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols.html#/c:@M@madme_ios_sdk@objc(pl)MMSdkDelegateProtocol">MMSdkDelegateProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/MMUrlProcessingResultProtocol.html">MMUrlProcessingResultProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/MMUrlSessionEventsProcessingResultProtocol.html">MMUrlSessionEventsProcessingResultProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/MMUserAccountStatusChangeContextProtocol.html">MMUserAccountStatusChangeContextProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/MMUserAccountStatusDelegateProtocol.html">MMUserAccountStatusDelegateProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/PaddingProtocol.html">PaddingProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/Updatable.html">Updatable</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Structs.html">Structures</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Structs/Digest.html">Digest</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Typealiases.html">Type Aliases</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Typealiases.html#/s:13madme_ios_sdk12MMIdentifiera">MMIdentifier</a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <article class="main-content">
        <section>
          <section class="section">
            
            <h1 id='readme' class='heading'>README</h1>

<p><img src="mAdmeLogo.png" alt="Image"></p>
<h3 id='confidentiality' class='heading'>Confidentiality</h3>

<p>This Document is confidential to mAdme and its affiliates (&ldquo;mAdme&rdquo;) and is provided by mAdme directly to the recipient on the strict understanding that no part of this document may be modified, translated, decompiled, disassembled, reproduced, used or transmitted by the recipient in any form without the prior written consent of mAdme. </p>

<p>© 2022 mAdme. All rights reserved.</p>
<h3 id='madme-ios-sdk-integration-steps' class='heading'>mAdme iOS SDK Integration Steps</h3>

<ol>
<li><p>Install Xcode 13.4.1 (iOS 11.0+, iOS 15.5 SDK, Swift 5.6.1 compiler).</p></li>
<li><p>Install Cocoapods 1.11.3.</p></li>
<li><p>Make sure you have Bitbucket and GitHub access (https/ssh).</p></li>
<li><p>Define a Podfile similar to the following (replace project and target names):</p>
<pre class="highlight plaintext"><code>platform :ios, '11.0'

use_frameworks!

source 'https://cdn.cocoapods.org/'
source 'https://bitbucket.org/madme/madme_ios_framework_podspecs.git'

project 'mAdme Sample Objc App.xcodeproj'

def pods
    # Core mAdme SDK. 
    pod 'madme_ios_sdk_framework/Debug+RSA', '~&gt; 6.2.1'
    # mAdme FCM wrapper (for mAdme SDK-driven FCM integration, if required). 
    pod 'madme_ios_fcm_wrapper_framework/Debug', '~&gt; 9.1.0'
end

target 'mAdme Sample Objc App' do
    pods
end

post_install do |installer_representation|
    installer_representation.pods_project.targets.each do |target|
        target.build_configurations.each do |config|
            config.build_settings['ONLY_ACTIVE_ARCH'] = 'NO'

                config.build_settings['SWIFT_VERSION'] = '5.6'

            config.build_settings['SWIFT_OPTIMIZATION_LEVEL'] = '-Osize'
            config.build_settings['SWIFT_COMPILATION_MODE'] = 'wholemodule'

            config.build_settings['BUILD_LIBRARY_FOR_DISTRIBUTION'] = 'YES'            
        end
    end
end
</code></pre></li>
<li><p>Run &lsquo;pod install&rsquo; and make sure it runs without warnings or errors. </p></li>
<li><p>Enable push notifications in the project&rsquo;s capabilities.</p></li>
<li><p>Enable the following background modes: </p>
<pre class="highlight plaintext"><code>- Background fetch, 
- Background processing, and 
- Remote notifications. 
</code></pre></li>
<li><p>Enable Access WiFi Information in the project&rsquo;s capabilities.  </p></li>
<li><p>Enable Multipath in the project&rsquo;s capabilities (if required). If not required, disable the feature in MMConfiguration.plist. </p></li>
<li><p>Update Info.plist to include strings required by the alerts presented when the application needs access to the user&rsquo;s location. See also RequestWhenInUseAuthorization and RequestAlwaysAuthorization in the MMConfiguration sample below:</p>
<pre class="highlight plaintext"><code>- Privacy - Location Always Usage Description,
- Privacy - Location When In Use Usage Description.
- Privacy - Location Always and When In Use Usage Description.
</code></pre></li>
<li><p>Update Info.plist to include the following background task identifiers: </p>
<pre class="highlight plaintext"><code>&lt;key&gt;BGTaskSchedulerPermittedIdentifiers&lt;/key&gt;
&lt;array&gt;
    &lt;string&gt;com.madme.bgRefreshTask&lt;/string&gt;
    &lt;string&gt;com.madme.bgProcessingTask&lt;/string&gt;
&lt;/array&gt;
</code></pre></li>
<li><p>Configure SDK to process mAdme background refresh tasks and background processing tasks as follows: </p>

<p><strong>Swift</strong></p>
<pre class="highlight plaintext"><code>func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]? = nil) -&gt; Bool {
    if #available(iOS 13.0, *) {                
        // Configure the SDK to process bg refresh tasks.
        MMSdk.configureBackgroundRefresh()

        // Configure the SDK to process bg processing tasks.
        MMSdk.configureBackgroundProcessing()
    }

    return true
}
</code></pre>

<p><strong>Objective-C</strong></p>
<pre class="highlight plaintext"><code>- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    if (@available(iOS 13.0, *)) {
        // Configure the SDK to process bg refresh tasks.
        [MMSdk configureBackgroundRefresh];

        // Configure the SDK to process bg processing tasks.
        [MMSdk configureBackgroundProcessing];
    }

    return YES;
}
</code></pre></li>
<li><p>Update Info.plist to allow for HTTP communication:</p>
<pre class="highlight plaintext"><code>&lt;key&gt;NSAppTransportSecurity&lt;/key&gt;
&lt;dict&gt;
    &lt;key&gt;NSAllowsArbitraryLoads&lt;/key&gt;
    &lt;true/&gt;
&lt;/dict&gt;
</code></pre></li>
<li><p>Update Info.plist to white-list any applications that may be used for deep linking or checked if installed. For example: </p>
<pre class="highlight plaintext"><code>&lt;key&gt;LSApplicationQueriesSchemes&lt;/key&gt;
&lt;array&gt;
    &lt;string&gt;$(PRODUCT_BUNDLE_IDENTIFIER)&lt;/string&gt;
    &lt;string&gt;fb&lt;/string&gt;
&lt;/array&gt;
</code></pre></li>
<li><p>Update Info.plist with supported URL types. For example: </p>
<pre class="highlight plaintext"><code>&lt;key&gt;CFBundleURLTypes&lt;/key&gt;
&lt;array&gt;
    &lt;dict&gt;
        &lt;key&gt;CFBundleTypeRole&lt;/key&gt;
        &lt;string&gt;None&lt;/string&gt;
        &lt;key&gt;CFBundleURLName&lt;/key&gt;
        &lt;string&gt;$(PRODUCT_BUNDLE_IDENTIFIER).url&lt;/string&gt;
        &lt;key&gt;CFBundleURLSchemes&lt;/key&gt;
        &lt;array&gt;
            &lt;string&gt;$(PRODUCT_BUNDLE_IDENTIFIER)&lt;/string&gt;
        &lt;/array&gt;
    &lt;/dict&gt;
&lt;/array&gt;
</code></pre></li>
<li><p>If required, update Info.plist to add FirebaseAppDelegateProxyEnabled flag set to NO. </p></li>
<li><p>Reference a module.modulemap file (if required) that includes the following: </p>
<pre class="highlight plaintext"><code>module Firebase {
    requires objc
}
</code></pre></li>
<li><p>Reference a MMConfiguration.plist file (e.g., <a href="./MMConfiguration.plist">MMConfiguration.plist</a>).  Madme will provide one based on the required configuration. If performing a production upgrade please double check with Madme before upgrading MMConfiguration.plist. See also the sample project(s) at <a href="https://bitbucket.org/madme/madme_ios_samples">https://bitbucket.org/madme/madme_ios_samples</a>. </p></li>
<li><p>Reference a Localizable.strings file. Madme will provide this. See the sample project at <a href="https://bitbucket.org/madme/madme_ios_samples">https://bitbucket.org/madme/madme_ios_samples</a>. </p></li>
<li><p>Reference a MMAssets.xcassets folder. Madme will provide this. See the sample project at <a href="https://bitbucket.org/madme/madme_ios_samples">https://bitbucket.org/madme/madme_ios_samples</a>. </p></li>
<li><p>For mAdme SDK-driven FCM integration (if required): </p>

<p>21.1. Link against madme_ios_fcm_wrapper_framework as per the above Podfile.  </p>

<p>21.2. Update the application code as per the code excerpts below. For more information see the sample project(s) at <a href="https://bitbucket.org/madme/madme_ios_samples">https://bitbucket.org/madme/madme_ios_samples</a>. FCM iOS documentation at <a href="https://firebase.google.com/docs/cloud-messaging/ios/client">https://firebase.google.com/docs/cloud-messaging/ios/client</a>. </p>

<p>21.3. Disable the Firebase app delegate proxy in Info.plist. </p>

<p>21.4. If required, reference a module.modulemap file that contains the following code (may require updating the application project&rsquo;s HEADER_SEARCH_PATHS): </p>
<pre class="highlight plaintext"><code>module Firebase {
    requires objc
}
</code></pre></li>
<li><p>Alternatively, for client application-driven FCM integration (if required): </p>

<p>22.1. Forward the FCM token to the mAdme SDK as follows: </p>

<p><strong>Swift</strong> </p>
<pre class="highlight plaintext"><code>func application(_ application: UIApplication, didRegisterForRemoteNotificationsWithDeviceToken deviceToken: Data) {
    // TODO: Application to retrieve the FCM token.
    let fcmTokenStr = "someFCMToken"

    // Forward the FCM token to the mAdme SDK.
    sdk.configureRemoteNotifications(with: fcmTokenStr)
}
</code></pre>

<p><strong>Objective-C</strong></p>
<pre class="highlight plaintext"><code>- (void)application:(UIApplication *)application didRegisterForRemoteNotificationsWithDeviceToken:(NSData *)deviceToken {
    // TODO: Application to retrieve the FCM token. 
    NSString *fcmTokenStr = @"someFCMToken";

    // Forward the FCM token to the mAdme SDK. 
    [self.mAdmeSdk configureRemoteNotificationsWith: fcmTokenStr];
}
</code></pre></li>
<li><p>Reference an rsa_public_key.der file. Madme will provide one based on the required configuration.</p></li>
<li><p>If required, reference a madme_cert.der file for certificate pinning. Madme will provide one based on the required configuration. Note that this feature can be enabled/disabled in MMConfiguration.plist.  </p></li>
<li><p>Add a DEBUG=1 preprocessor macro (if application written in Objective-C) or -D DEBUG other Swift flag (if application written in Swift) to the application&rsquo;s project/target Debug build configuration. Edit project.pbxproj directly. </p></li>
<li><p>If required, add a APNS_PRODUCTION=1 preprocessor macro (if application written in Objective-C) or -D APNS_PRODUCTION other Swift flag (if application written in Swift) to the application&rsquo;s project/target Release/TestFlight/&hellip; build configuration. Edit project.pbxproj directly.  </p></li>
<li><p>If the application is written in Objective-C make sure that the Always Embed Swift Standard Libraries build setting is set to Yes.  </p></li>
<li><p>Set up the minimum background fetch interval. For example: </p>

<p><strong>Swift</strong></p>
<pre class="highlight plaintext"><code>func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]? = nil) -&gt; Bool {
    // Set setMinimumBackgroundFetchInterval.
    application.setMinimumBackgroundFetchInterval(UIApplication.backgroundFetchIntervalMinimum)

    return true
}
</code></pre>

<p><strong>Objective-C</strong></p>
<pre class="highlight plaintext"><code>- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Set setMinimumBackgroundFetchInterval.
    [application setMinimumBackgroundFetchInterval: UIApplicationBackgroundFetchIntervalMinimum];

    return YES;
}
</code></pre></li>
<li><p>Set up the mAdme SDK logging. For example: </p>

<p><strong>Swift</strong></p>
<pre class="highlight plaintext"><code>import madme_ios_sdk_shared

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Configure logging. The following #if assumes a preprocessor macro "DEBUG=1" e.g., for all Debug targets.
    #if DEBUG
        MMLogger.type = .full
    #else
        MMLogger.type = .none
    #endif

    return true
}
</code></pre>

<p><strong>Objective-C</strong></p>
<pre class="highlight plaintext"><code>@import madme_ios_sdk_shared;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Configure logging. The following #if assumes a preprocessor macro "DEBUG=1" e.g., for all Debug targets.
    #if DEBUG
        [MMLogger setType: MMLoggerTypeFull];
    #else
        [MMLogger setType: MMLoggerTypeNone];
    #endif

    return YES;
}
</code></pre></li>
<li><p>Initialize the mAdme SDK and set its delegate. Make sure to initialize the mAdme SDK before application(_:didFinishLaunchingWithOptions:) completes. For example: </p>

<p><strong>Swift</strong></p>
<pre class="highlight plaintext"><code>import madme_ios_sdk_sdk

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Init the sdk and set its delegate.
    sdk.delegate = self
}

let sdk = MMSdk.sharedInstance
</code></pre>

<p><strong>Objective-C</strong></p>
<pre class="highlight plaintext"><code>@import madme_ios_sdk;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Init and configure the mAdme SDK.
    [self mAdmeSdk];

    return YES;
}

@interface AppDelegate (mAdmeSdk)

@property (nonatomic, readonly, copy) MMSdk * _Nonnull mAdmeSdk;

@end

@implementation AppDelegate (mAdmeSdk)

///
/// MARK: mAdme SDK instance.
///

- (MMSdk * _Nonnull)mAdmeSdk {
    static MMSdk * _Nonnull mAdmeSdk;

    static dispatch_once_t onceToken;

    dispatch_once(&amp;onceToken, ^{
        // Get a reference to the mAdme SDK.
        mAdmeSdk = MMSdk.sharedInstance;

        // Set self as delegate.
        mAdmeSdk.delegate = self;
    });

    return mAdmeSdk;
}

@end
</code></pre></li>
<li><p>Configure the oAuth2Id, oAuth2Secret and optional oClientIds. Madme will provide oAuth2Id and oAuth2Secret for your particular build configuration. For example: </p>

<p><strong>Swift</strong></p>
<pre class="highlight plaintext"><code>extension AppDelegate: MMSdkDelegateProtocol {

    var oAuth2Id: String {
        return "eoc-ios-v1"
    }

    var oAuth2Secret: String {
        return "30489gb4w9tv93q"
    }

    @objc var oClientIds: [String: String]? {
        return nil
    }    
}
</code></pre>

<p><strong>Objective-C</strong></p>
<pre class="highlight plaintext"><code>@interface AppDelegate (MMSdkDelegateProtocol) &lt;MMSdkDelegateProtocol&gt;

@property (nonatomic, readonly, copy) NSString * _Nonnull oAuth2Id;

@property (nonatomic, readonly, copy) NSString * _Nonnull oAuth2Secret;

@property (nonatomic, readonly, copy) NSDictionary&lt;NSString *, NSString *&gt; * _Nullable oClientIds;

@end

@implementation AppDelegate (MMSdkDelegateProtocol)

- (NSString * _Nonnull)oAuth2Id {
    return @"eoc-ios-v1";
}

- (NSString * _Nonnull)oAuth2Secret {
    return @"30489gb4w9tv93q";
}

- (NSDictionary&lt;NSString *, NSString *&gt; * _Nullable)oClientIds {
    return nil;
}

@end
</code></pre></li>
<li><p>Forward local and remote notifications to the mAdme SDK. Check the SDK&rsquo;s response to know if these were mAdme notifications. For example: </p>

<p><strong>Swift</strong></p>
<pre class="highlight plaintext"><code>//
// MARK: Notifications common. 
//

func process(notificationPayload: [AnyHashable: Any], oResultClosure: ((_ notificationProcessingResult: MMNotificationProcessingResultProtocol) -&gt; Void)? = nil) {
    // Ask the SDK to process the notification.
    sdk.process(notificationPayload: notificationPayload) { notificationProcessingResult in
        switch notificationProcessingResult.state {
        case .notificationProcessedSucessfully:
            // TODO: ...

        case .notificationProcessedUnsuccessfully:
            // TODO: ...

        case .notificationNotProcessed:
            // TODO: ...

        @unknown default:
            // TODO: ...
        }

        // Finally, call the closure.
        oResultClosure?(notificationProcessingResult)
    }
}

///
/// MARK: Managing local mAdme notifications.
///

func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]? = nil) -&gt; Bool {
    // Set self as UNUserNotificationCenterDelegate delegate.
    UNUserNotificationCenter.current().delegate = self

    return true
}

extension AppDelegate: UNUserNotificationCenterDelegate {

    func userNotificationCenter(_ center: UNUserNotificationCenter, didReceive response: UNNotificationResponse, withCompletionHandler completionHandler: @escaping () -&gt; Swift.Void) {
        // Forward to the sdk.
        process(notificationPayload: response.notification.request.content.userInfo) { response in
            // Call the completion handler.
            completionHandler()
        }
    }
}

///
/// MARK: Managing remote mAdme notifications. madme_ios_fcm_wrapper and fcmRemoteNotificationsConfigurationManager for mAdme SDK-driven FCM integration, if required.  
///

import madme_ios_fcm_wrapper

func application(_ application: UIApplication, didRegisterForRemoteNotificationsWithDeviceToken deviceToken: Data) {
    // Decide whether to use the sandbox or production APNs.
    #if APNS_PRODUCTION
    let useProductionApns = true
    #else
    let useProductionApns = false
    #endif

    // Re-configure the SDK's notifications.
    MMFCMRemoteNotificationsConfigurationManager.sharedInstance.configureNotifications(deviceToken: deviceToken, useProductionApns: useProductionApns)
}

func application(_ application: UIApplication, didFailToRegisterForRemoteNotificationsWithError error: Error) {
    // TODO: ... 
}

func application(_ application: UIApplication, didReceiveRemoteNotification userInfo: [AnyHashable: Any], fetchCompletionHandler completionHandler: @escaping (UIBackgroundFetchResult) -&gt; Swift.Void) {
    // Process the notification payload.
    process(notificationPayload: userInfo) { notificationProcessingResult in
        // Infer the handler's input from the notificationProcessingResult.
        switch notificationProcessingResult.state {
        case .notificationProcessedSucessfully:
            // Call the handler.
            completionHandler(.newData)

        case .notificationNotProcessed, .notificationProcessedUnsuccessfully:
            // Call the handler.
            completionHandler(.failed)

        @unknown default:
            // Call the handler.
            completionHandler(.failed)
        }
    }
}
</code></pre>

<p><strong>Objective-C</strong></p>
<pre class="highlight plaintext"><code>//
// MARK: Notifications common. 
//

- (void)processNotificationPayload:(NSDictionary * _Nullable)notificationPayload fetchCompletionHandler:(void (^_Nullable)(UIBackgroundFetchResult result))completionHandler {
    // Check that there is a payload to process.
    if (notificationPayload) {
        // Ask mAdme to process it.
        [self.mAdmeSdk processWithNotificationPayload: notificationPayload oResultClosure:^(id&lt;MMNotificationProcessingResultProtocol&gt; _Nonnull notificationProcessingResult) {
            switch (notificationProcessingResult.state) {
                case MMNotificationProcessingResultStateNotificationProcessedSucessfully:
                // TODO: ...

                // Call the handler.
                completionHandler ? completionHandler(UIBackgroundFetchResultNewData) : nil;

                break;

                case MMNotificationProcessingResultStateNotificationProcessedUnsuccessfully:
                // TODO: ...

                // Call the handler.
                completionHandler ? completionHandler(UIBackgroundFetchResultFailed) : nil;

                break;

                case MMNotificationProcessingResultStateNotificationNotProcessed:
                // TODO: ...

                // Call the handler.
                completionHandler ? completionHandler(UIBackgroundFetchResultNoData) : nil;

                break;
            }
        }];
    }
}

///
/// MARK: Managing local mAdme notifications.
///

@implementation AppDelegate

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Set self as UNUserNotificationCenterDelegate delegate.
    [UNUserNotificationCenter currentNotificationCenter].delegate = self;

    return YES;
}

@implementation AppDelegate (UNUserNotificationCenterDelegate)

- (void)userNotificationCenter:(UNUserNotificationCenter *)center didReceiveNotificationResponse:(UNNotificationResponse *)response withCompletionHandler:(void(^)(void))completionHandler {
    // Process the notification payload.
    [self processNotificationPayload: response.notification.request.content.userInfo fetchCompletionHandler: ^(UIBackgroundFetchResult result) {
        // Call the completionHandler.
        completionHandler();
    }];
}

@end

///
/// MARK: Managing remote mAdme notifications. madme_ios_fcm_wrapper and fcmRemoteNotificationsConfigurationManager for mAdme SDK-driven FCM integration, if required.  
///

@import madme_ios_fcm_wrapper;

- (void)application:(UIApplication *)application didRegisterForRemoteNotificationsWithDeviceToken:(NSData *)deviceToken {
    // Decide whether to use the sandbox or production APNs.
    #if DEBUG
        BOOL useProductionApns = NO;
    #else
        BOOL useProductionApns = YES;
    #endif

    // Re-configure the SDK's notifications.
    [self.fcmRemoteNotificationsConfigurationManager configureNotificationsWithDeviceToken: deviceToken useProductionApns: useProductionApns];
}

- (void)application:(UIApplication *)application didFailToRegisterForRemoteNotificationsWithError:(NSError *)error {
    // TODO: ...
}

- (void)application:(UIApplication *)application didReceiveRemoteNotification:(NSDictionary *)userInfo fetchCompletionHandler: (void (^)(UIBackgroundFetchResult result))completionHandler {
    // Process the notification payload.
    [self processNotificationPayload: userInfo fetchCompletionHandler: completionHandler];
}

- (MMFCMRemoteNotificationsConfigurationManager * _Nonnull)fcmRemoteNotificationsConfigurationManager {
    static MMFCMRemoteNotificationsConfigurationManager * _Nonnull fcmRemoteNotificationsConfigurationManager;

    static dispatch_once_t onceToken;

    dispatch_once(&amp;onceToken, ^{
        // Get a reference to the manager.
        fcmRemoteNotificationsConfigurationManager = MMFCMRemoteNotificationsConfigurationManager.sharedInstance;
    });

    return fcmRemoteNotificationsConfigurationManager;
}
</code></pre></li>
<li><p>Forward background URL session events to the mAdme SDK. For example: </p>

<p><strong>Swift</strong></p>
<pre class="highlight plaintext"><code>func application(_ application: UIApplication, handleEventsForBackgroundURLSession identifier: String, completionHandler: @escaping () -&gt; Swift.Void) {
    // Forward call to mAdme SDK.
    sdk.handleEventsForBackgroundURLSession(identifier: identifier) { _ in
        // TODO: ...

        // Call completionHandler.
        completionHandler()
    }
}
</code></pre>

<p><strong>Objective-C</strong></p>
<pre class="highlight plaintext"><code>- (void)application:(UIApplication *)application handleEventsForBackgroundURLSession:(NSString *)identifier completionHandler:(void (^)(void))completionHandler {
    // Forward call to mAdme SDK.
    [self.mAdmeSdk handleEventsForBackgroundURLSessionWithIdentifier: identifier resultClosure:^(id&lt;MMUrlSessionEventsProcessingResultProtocol&gt; _Nonnull urlSessionEventsProcessingResult) {
        // TODO: ...

        // Call completionHandler.
        completionHandler();
    }];
}
</code></pre></li>
<li><p>If required, forward open URL requests to the mAdme SDK. For example: </p>

<p><strong>Swift</strong></p>
<pre class="highlight plaintext"><code>func processUrl(url: URL) -&gt; Bool {
    // Ask the MMSdk to process the url.
    return sdk.process(url: url) { urlProcessingResult in
        switch urlProcessingResult.state {
        case .urlNotProcessed:
            // TODO: ...
            break

        case .urlProcessedSucessfully:
            // TODO: ...
            break

        case .urlProcessedUnsuccessfully:
            // TODO: ...
            break

        @unknown default:
            // TODO: ...
            break
        }
    }
}

@objc(application:openURL:options:) func application(_ app: UIApplication, open url: URL, options: [UIApplication.OpenURLOptionsKey: Any] = [:]) -&gt; Bool {
    // Process the url.
    return processUrl(url: url)
}
</code></pre>

<p><strong>Objective-C</strong></p>
<pre class="highlight plaintext"><code>- (BOOL)processUrl:(NSURL *)url {
    // Ask MMSdk to process the url.
    return [self.mAdmeSdk processWithUrl: url oResultClosure:^(id&lt;MMUrlProcessingResultProtocol&gt; _Nonnull urlProcessingResult) {
        switch (urlProcessingResult.state) {
            case MMUrlProcessingResultStateUrlProcessedSucessfully:
            // TODO: ...
            break;

            case MMUrlProcessingResultStateUrlProcessedUnsuccessfully:
            // TODO: ...
            break;

            case MMUrlProcessingResultStateUrlNotProcessed:
            // TODO: ...
            break;
        }
    }];
}

- (BOOL)application:(UIApplication *)app openURL:(NSURL *)url options:(NSDictionary&lt;UIApplicationOpenURLOptionsKey, id&gt; *)options {
    // Process the url.
    return [self processUrl: url];
}
</code></pre></li>
<li><p>Forward background fetch calls to the mAdme SDK. For example: </p>

<p><strong>Swift</strong></p>
<pre class="highlight plaintext"><code>func application(_ application: UIApplication, performFetchWithCompletionHandler completionHandler: @escaping (UIBackgroundFetchResult) -&gt; Swift.Void) {
    // Forward call to MMSdk.
    sdk.application(application, performFetchWithCompletionHandler: completionHandler)
}
</code></pre>

<p><strong>Objective-C</strong></p>
<pre class="highlight plaintext"><code>- (void)application:(UIApplication *)application performFetchWithCompletionHandler:(void (^)(UIBackgroundFetchResult))completionHandler {
    // Forward call to MMSdk.
    [self.mAdmeSdk application: application performFetchWithCompletionHandler: completionHandler];
}
</code></pre></li>
<li><p>Optionally update MMConfiguration.plist&rsquo;s scheduler time intervals, UI colors, border widths, etc.    </p></li>
<li><p>Sample code of using the mAdme SDK to present an In-App campaign. </p>

<p><strong>Swift</strong></p>
<pre class="highlight plaintext"><code>import madme_ios_sdk

final class ApplicationViewController: UIViewController {

    override func viewDidLoad() {
        super.viewDidLoad()

        // Some time later... Delay here just for demo purposes.
        DispatchQueue.main.asyncAfter(deadline: .now() + 10.0) {
            MMSdk.sharedInstance.presentAd(tags: ["SAMPLE_TAG"], tagsAggregateQualifier: .any, adPresentationMode: .direct, oParentViewController: nil) { adPresentationResult in
                // Direct flow based on the adPresentationResult's state.
                switch adPresentationResult.state {
                case .adNotPresented:
                    // TODO: ...
                    break

                case .adViewed:
                    // TODO: ...
                    break

                case .adTapped:
                    // TODO: ...
                    break

                case .adViewedAndTapped:
                    // TODO: ...
                    break

                case .adDismissed:
                    // TODO: ...
                    break

                case .adNotified:
                    // TODO: ...
                    break

                case .adNotifyFailed:
                    // TODO: ...
                    break

                @unknown default:
                    // TODO: ...
                    break
                }
            }
        }
    }
}
</code></pre>

<p><strong>Objective-C</strong></p>
<pre class="highlight plaintext"><code>#import "ViewController.h"
#import "AppDelegate.h"

@import madme_ios_sdk;

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    // Some time later... Delay here just for demo purposes.
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, 10.0 * NSEC_PER_SEC), dispatch_get_main_queue(), ^{
        // Ask the mAdmeSdk to present an ad with a specific tag.
        [((AppDelegate *)(UIApplication.sharedApplication.delegate)).mAdmeSdk presentAdWithTags: [NSSet setWithObject: @"SAMPLE_TAG"] tagsAggregateQualifier: MMAggregateQualifierAny adPresentationMode: MMAdPresentationModeDirect oParentViewController: nil oResultClosure: ^(id&lt;MMAdPresentationResultProtocol&gt; _Nonnull adPresentationResult) {
            // Direct flow based on the adPresentationResult's state.
            switch (adPresentationResult.state) {
                case MMAdPresentationResultStateAdNotPresented:
                    // TODO: ...
                    break;

                case MMAdPresentationResultStateAdViewed:
                    // TODO: ...
                    break;

                case MMAdPresentationResultStateAdTapped:
                    // TODO: ...
                    break;

                case MMAdPresentationResultStateAdViewedAndTapped:
                    // TODO: ...
                    break;

                case MMAdPresentationResultStateAdDismissed:
                    // TODO: ...
                    break;

                case MMAdPresentationResultStateAdNotified:
                    // TODO: ...
                    break;

                case MMAdPresentationResultStateAdNotifyFailed:
                    // TODO: ...
                    break;
            }
        }];
    });
}

@end
</code></pre></li>
<li><p>Client apps can receive up-to-date information on the viewed campaigns (surveys and rating campaigns excluded) by observing NSNotification.Campaigns as per the code below: </p>

<p><strong>Swift</strong></p>
<pre class="highlight plaintext"><code>// Observe .Campaigns notifications.
_ = NotificationCenter.default.addObserver(forName: .Campaigns, object: MMSdk.sharedInstance, queue: nil) { notification in
    // Get the campaigns (if any).
    guard let campaigns = notification.userInfo?[MMSdk.CampaignsKey] else {
        // TODO: ...
        return
    }

    // TODO: ...
}
</code></pre>

<p><strong>Objective-C</strong></p>
<pre class="highlight plaintext"><code>// Observe NSNotification.Campaigns notifications.
... = [NSNotificationCenter.defaultCenter addObserverForName: NSNotification.Campaigns object: mAdmeSdk queue: nil usingBlock: ^(NSNotification * _Nonnull notification) {
    // Get the campaigns (if any).
    NSArray&lt;MMCampaign *&gt; *campaigns = notification.userInfo[MMSdk.CampaignsKey];

    // Log.
    NSLog(@"Got %lu campaigns.", (unsigned long)campaigns.count);
}];
</code></pre></li>
<li><p>For more information see the API docs at <a href="https://bitbucket.org/madme/madme_ios_sdk_framework5/src/master/madme_ios_sdk_api_docs/index.html">https://bitbucket.org/madme/madme_ios_sdk_framework5/src/master/madme_ios_sdk_api_docs/index.html</a>. </p></li>
</ol>

          </section>
        </section>
        <section id="footer">
          <p>&copy; 2022 <a class="link" href="http://www.mad-me.com" target="_blank" rel="external noopener">mAdme</a>. All rights reserved. (Last updated: 2022-07-05)</p>
          <p>Generated by <a class="link" href="https://github.com/realm/jazzy" target="_blank" rel="external noopener">jazzy ♪♫ v0.14.2</a>, a <a class="link" href="https://realm.io" target="_blank" rel="external noopener">Realm</a> project.</p>
        </section>
      </article>
    </div>
  </body>
</html>
